diff -Naur gcc-2.95.3.old/configure.in gcc-2.95.3/configure.in
--- gcc-2.95.3.old/configure.in	Thu Jan  4 21:07:37 2001
+++ gcc-2.95.3/configure.in	Mon May 27 07:05:27 2002
@@ -637,6 +637,7 @@
     ;;
   *-*-linux*)
     # linux has rx in libc
+    noconfigdirs="$noconfigdirs target-libstdc++ target-libio target-libiberty target-libf2c target-libobjc target-libchill"
     skipdirs="$skipdirs target-librx"
     ;;
   i[3456]86-*-mingw32*)
diff -Naur gcc-2.95.3.old/gcc/cccp.c gcc-2.95.3/gcc/cccp.c
--- gcc-2.95.3.old/gcc/cccp.c	Wed Mar  8 13:22:44 2000
+++ gcc-2.95.3/gcc/cccp.c	Mon May 27 07:05:27 2002
@@ -384,50 +384,7 @@
 				   be wrapped in extern "C" when compiling
 				   C++.  */
   int included;                 /* Set if the directory is acceptable.  */
-} include_defaults_array[]
-#ifdef INCLUDE_DEFAULTS
-  = INCLUDE_DEFAULTS;
-#else
-  = {
-    /* Pick up GNU C++ specific include files.  */
-    { GPLUSPLUS_INCLUDE_DIR, "G++", 1, 1, 0 },
-#ifdef CROSS_COMPILE
-    /* This is the dir for fixincludes.  Put it just before
-       the files that we fix.  */
-    { GCC_INCLUDE_DIR, "GCC", 0, 0, 0 },
-    /* For cross-compilation, this dir name is generated
-       automatically in Makefile.in.  */
-    { CROSS_INCLUDE_DIR, "GCC", 0, 0, 0 },
-#ifdef TOOL_INCLUDE_DIR
-    /* This is another place that the target system's headers might be.  */
-    { TOOL_INCLUDE_DIR, "BINUTILS", 0, 0, 0 },
-#endif
-#else /* not CROSS_COMPILE */
-#ifdef LOCAL_INCLUDE_DIR
-    /* This should be /usr/local/include and should come before
-       the fixincludes-fixed header files.  */
-    { LOCAL_INCLUDE_DIR, 0, 0, 1, 0 },
-#endif
-#ifdef TOOL_INCLUDE_DIR
-    /* This is here ahead of GCC_INCLUDE_DIR because assert.h goes here.
-       Likewise, behind LOCAL_INCLUDE_DIR, where glibc puts its assert.h.  */
-    { TOOL_INCLUDE_DIR, "BINUTILS", 0, 0, 0 },
-#endif
-    /* This is the dir for fixincludes.  Put it just before
-       the files that we fix.  */
-    { GCC_INCLUDE_DIR, "GCC", 0, 0, 0 },
-    /* Some systems have an extra dir of include files.  */
-#ifdef SYSTEM_INCLUDE_DIR
-    { SYSTEM_INCLUDE_DIR, 0, 0, 0, 0 },
-#endif
-#ifndef STANDARD_INCLUDE_COMPONENT
-#define STANDARD_INCLUDE_COMPONENT 0
-#endif
-    { STANDARD_INCLUDE_DIR, STANDARD_INCLUDE_COMPONENT, 0, 0, 0 },
-#endif /* not CROSS_COMPILE */
-    { 0, 0, 0, 0, 0 }
-    };
-#endif /* no INCLUDE_DEFAULTS */
+} include_defaults_array[10];
 
 /* The code looks at the defaults through this pointer, rather than through
    the constant structure above.  This pointer gets changed if an environment
@@ -1018,6 +975,10 @@
 
 static void memory_full PROTO((void)) ATTRIBUTE_NORETURN;
 static void print_help PROTO((void));
+
+extern char *replace(char*, char*);
+extern int find_family_cpu(char **);
+extern char *get_std_prefix();
 
 /* Read LEN bytes at PTR from descriptor DESC, for file FILENAME,
    retrying if necessary.  If MAX_READ_LEN is defined, read at most
@@ -1226,6 +1187,156 @@
   FILE *deps_stream = 0;
   /* Target-name to write with the dependency information.  */
   char *deps_target = 0;
+
+#define add_to_include(_var, _fname, _component, _cplusplus, _cxx_aware, _included) \
+  do { _var.fname     = _fname;      \
+       _var.component = _component;  \
+       _var.cplusplus = _cplusplus;  \
+       _var.cxx_aware = _cxx_aware;  \
+       _var.included  = _included; } while (0);
+
+
+  char *cross_dir;
+  char *family_cpu;
+  int ind = 0;
+
+
+  if (!find_family_cpu(&family_cpu)) {
+    fatal("The CROSS_COMPILE environment variable is not set");
+  }
+
+  /* Set new standard prefix to use instead of /cdt */
+  find_cross_dir(argv[0], &cross_dir, 1);
+  if (cross_dir)
+  {
+    set_std_prefix(cross_dir, strlen(cross_dir));
+
+  /* Generate the include_defaults_array. It can not be initialized because
+     some paths can depend on values of environment variables */
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, GPLUSPLUS_INCLUDE_DIR), 
+                   "G++", 1, 1, 0);
+    ind++;
+#ifdef CROSS_COMPILE
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, GCC_INCLUDE_DIR), 
+                   "GCC", 0, 0, 0);
+    ind++;
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, CROSS_INCLUDE_DIR),
+                   "GCC", 0, 0, 0);
+    ind++;
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, TOOL_INCLUDE_DIR),
+                   "BINUTILS", 0, 1, 0);
+    ind++;
+#endif
+    {
+      char *target_include_dir = concat(cross_dir, "/../", family_cpu,  
+                                        "/usr/include", NULL_PTR);
+      char * gxx_target_include_dir = concat(cross_dir, "/../", family_cpu,
+                                         "/usr/include/g++-3", NULL_PTR);
+      if (gxx_target_include_dir) {
+        add_to_include(include_defaults_array[ind], gxx_target_include_dir,
+                       0, 1, 1, 0);
+        ind++;
+      }
+
+      if (target_include_dir) {
+        add_to_include(include_defaults_array[ind], target_include_dir,
+                       0, 0, 0, 0);
+        ind++;
+      }
+    }
+#else /* not CROSS_COMPILE */
+#ifdef LOCAL_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, LOCAL_INCLUDE_DIR), 0, 0, 1, 0);
+    ind++;
+#endif
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, TOOL_INCLUDE_DIR),
+                   "BINUTILS", 0, 1, 0);
+    ind++;
+#endif
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, GCC_INCLUDE_DIR), 
+                   "GCC", 0, 0, 0);
+    ind++;
+#ifdef SYSTEM_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], 
+                   replace(cross_dir, SYSTEM_INCLUDE_DIR), 
+                   0, 0, 0, 0);
+    ind++;
+#endif
+#endif /* not CROSS_COMPILE */
+  }
+  else {
+    /* cross_dir can not be determined */
+    add_to_include(include_defaults_array[ind], 
+                   GPLUSPLUS_INCLUDE_DIR, 
+                   "G++", 1, 1, 0);
+    ind++;
+#ifdef CROSS_COMPILE
+    add_to_include(include_defaults_array[ind], 
+                   GCC_INCLUDE_DIR, 
+                   "GCC", 0, 0, 0);
+    ind++;
+    add_to_include(include_defaults_array[ind], CROSS_INCLUDE_DIR,
+                   "GCC", 0, 0, 0);
+    ind++;
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], TOOL_INCLUDE_DIR,
+                   "BINUTILS", 0, 1, 0);
+    ind++;
+#endif
+    {
+      char *target_include_dir = concat(get_std_prefix(), "/../", 
+                                        family_cpu, "/usr/include", NULL_PTR);
+      char * gxx_target_include_dir = concat(get_std_prefix(), "/../", 
+                                         family_cpu, "/usr/include/g++-3",
+                                         NULL_PTR);
+      if (gxx_target_include_dir) {
+        add_to_include(include_defaults_array[ind], gxx_target_include_dir,
+                       0, 1, 1, 0);
+        ind++;
+      }
+
+      if (target_include_dir) {
+        add_to_include(include_defaults_array[ind], target_include_dir,
+                       0, 0, 0, 0);
+        ind++;
+      }
+  }
+#else /* not CROSS_COMPILE */
+#ifdef LOCAL_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], LOCAL_INCLUDE_DIR, 0, 0, 1, 0);
+    ind++;
+#endif
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], TOOL_INCLUDE_DIR,
+                   "BINUTILS", 0, 1, 0);
+    ind++;
+#endif
+    add_to_include(include_defaults_array[ind], GCC_INCLUDE_DIR, 
+                   "GCC", 0, 0, 0);
+    ind++;
+#ifdef SYSTEM_INCLUDE_DIR
+    add_to_include(include_defaults_array[ind], SYSTEM_INCLUDE_DIR, 
+                   0, 0, 0, 0);
+    ind++;
+#endif
+#endif /* not CROSS_COMPILE */
+  }
+
+#if !defined(CROSS_COMPILE) && !defined(STANDARD_INCLUDE_COMPONENT)
+#define STANDARD_INCLUDE_COMPONENT 0
+#endif 
+  add_to_include(include_defaults_array[ind], 0, 0, 0, 0, 0 );
+
+#undef add_to_include
 
 #if defined (RLIMIT_STACK) && defined (HAVE_GETRLIMIT) && defined (HAVE_SETRLIMIT)
   /* Get rid of any avoidable limit on stack size.  */
diff -Naur gcc-2.95.3.old/gcc/config/rs6000/rs6000.c gcc-2.95.3/gcc/config/rs6000/rs6000.c
--- gcc-2.95.3.old/gcc/config/rs6000/rs6000.c	Fri Jan 12 02:52:53 2001
+++ gcc-2.95.3/gcc/config/rs6000/rs6000.c	Mon May 27 07:05:27 2002
@@ -216,6 +216,9 @@
 	 {"403", PROCESSOR_PPC403,
 	    MASK_POWERPC | MASK_SOFT_FLOAT | MASK_NEW_MNEMONICS | MASK_STRICT_ALIGN,
 	    POWER_MASKS | POWERPC_OPT_MASKS | MASK_POWERPC64},
+	 {"405pm", PROCESSOR_PPC403,
+	    MASK_POWERPC | MASK_NEW_MNEMONICS | MASK_STRICT_ALIGN,
+	    POWER_MASKS | POWERPC_OPT_MASKS | MASK_POWERPC64},
 	 {"505", PROCESSOR_MPCCORE,
 	    MASK_POWERPC | MASK_NEW_MNEMONICS,
 	    POWER_MASKS | POWERPC_OPT_MASKS | MASK_POWERPC64},
@@ -246,6 +249,9 @@
 	 {"740", PROCESSOR_PPC750,
  	    MASK_POWERPC | MASK_PPC_GFXOPT | MASK_NEW_MNEMONICS,
  	    POWER_MASKS | MASK_PPC_GPOPT | MASK_POWERPC64},
+	 {"7400", PROCESSOR_PPC750,
+	    MASK_POWERPC | MASK_PPC_GFXOPT | MASK_NEW_MNEMONICS,
+	    POWER_MASKS | MASK_PPC_GPOPT | MASK_POWERPC64},
 	 {"750", PROCESSOR_PPC750,
  	    MASK_POWERPC | MASK_PPC_GFXOPT | MASK_NEW_MNEMONICS,
  	    POWER_MASKS | MASK_PPC_GPOPT | MASK_POWERPC64},
diff -Naur gcc-2.95.3.old/gcc/config/rs6000/rs6000.h gcc-2.95.3/gcc/config/rs6000/rs6000.h
--- gcc-2.95.3.old/gcc/config/rs6000/rs6000.h	Thu Jan  4 21:07:38 2001
+++ gcc-2.95.3/gcc/config/rs6000/rs6000.h	Mon May 27 07:05:27 2002
@@ -72,6 +72,7 @@
 %{mcpu=rsc1: -D_ARCH_PWR} \
 %{mcpu=401: -D_ARCH_PPC} \
 %{mcpu=403: -D_ARCH_PPC} \
+%{mcpu=405pm: -D_ARCH_PPC} \
 %{mcpu=505: -D_ARCH_PPC} \
 %{mcpu=601: -D_ARCH_PPC -D_ARCH_PWR} \
 %{mcpu=602: -D_ARCH_PPC} \
@@ -82,6 +83,7 @@
 %{mcpu=604e: -D_ARCH_PPC} \
 %{mcpu=620: -D_ARCH_PPC} \
 %{mcpu=740: -D_ARCH_PPC} \
+%{mcpu=7400: -D_ARCH_PPC} \
 %{mcpu=750: -D_ARCH_PPC} \
 %{mcpu=801: -D_ARCH_PPC} \
 %{mcpu=821: -D_ARCH_PPC} \
@@ -138,6 +140,7 @@
 %{mcpu=604e: -mppc} \
 %{mcpu=620: -mppc} \
 %{mcpu=740: -mppc} \
+%{mcpu=7400: -m7400} \
 %{mcpu=750: -mppc} \
 %{mcpu=801: -mppc} \
 %{mcpu=821: -mppc} \
diff -Naur gcc-2.95.3.old/gcc/config/rs6000/sysv4.h gcc-2.95.3/gcc/config/rs6000/sysv4.h
--- gcc-2.95.3.old/gcc/config/rs6000/sysv4.h	Thu Jan  4 21:07:38 2001
+++ gcc-2.95.3/gcc/config/rs6000/sysv4.h	Mon May 27 07:05:28 2002
@@ -1146,7 +1146,7 @@
 %{mcall-sysv: -D_CALL_SYSV} %{mcall-nt: -D_CALL_NT} \
 %{mcall-aix: -D_CALL_AIX} %{mcall-aixdesc: -D_CALL_AIX -D_CALL_AIXDESC} \
 %{!mcall-sysv: %{!mcall-aix: %{!mcall-aixdesc: %{!mcall-nt: %(cpp_sysv_default) }}}} \
-%{msoft-float: -D_SOFT_FLOAT} %{mcpu=403: -D_SOFT_FLOAT}"
+%{msoft-float: -D_SOFT_FLOAT} %{mcpu=860: -D_SOFT_FLOAT} %{mcpu=403: -D_SOFT_FLOAT}"
 
 #undef	CPP_SYSV_DEFAULT_SPEC
 #define	CPP_SYSV_DEFAULT_SPEC "-D_CALL_SYSV"
diff -Naur gcc-2.95.3.old/gcc/config/rs6000/t-ppcos gcc-2.95.3/gcc/config/rs6000/t-ppcos
--- gcc-2.95.3.old/gcc/config/rs6000/t-ppcos	Thu May 20 14:51:36 1999
+++ gcc-2.95.3/gcc/config/rs6000/t-ppcos	Mon May 27 07:05:27 2002
@@ -3,10 +3,9 @@
 
 # Build libgcc.a with different options.  With gas, build pic libraries
 # as well no floating point
-MULTILIB_OPTIONS	= msoft-float fPIC
-MULTILIB_DIRNAMES	= nof pic
+MULTILIB_OPTIONS        = mcpu=403/mcpu=7400/mcpu=750/mcpu=603/mcpu=860 fPIC
+MULTILIB_DIRNAMES       = m403 m7400 m750 m603 m860 pic
 MULTILIB_EXCEPTIONS	=
-MULTILIB_MATCHES	= ${MULTILIB_MATCHES_FLOAT} \
-			  fPIC=mrelocatable-lib \
+MULTILIB_MATCHES	= fPIC=mrelocatable-lib \
 			  fPIC=mrelocatable \
 			  fPIC=fpic
diff -Naur gcc-2.95.3.old/gcc/config/t-linux gcc-2.95.3/gcc/config/t-linux
--- gcc-2.95.3.old/gcc/config/t-linux	Thu May 20 14:51:36 1999
+++ gcc-2.95.3/gcc/config/t-linux	Mon May 27 07:05:27 2002
@@ -7,7 +7,7 @@
 # Compile crtbeginS.o and crtendS.o with pic.
 CRTSTUFF_T_CFLAGS_S = -fPIC
 # Compile libgcc2.a with pic.
-TARGET_LIBGCC2_CFLAGS = -fPIC
+TARGET_LIBGCC2_CFLAGS =  -fPIC -I../../gcc/glibc-include
 
 # Do not build libgcc1. Let gcc generate those functions. The GNU/Linux
 # C library can handle them.
diff -Naur gcc-2.95.3.old/gcc/cp/Make-lang.in gcc-2.95.3/gcc/cp/Make-lang.in
--- gcc-2.95.3.old/gcc/cp/Make-lang.in	Thu May 20 14:51:36 1999
+++ gcc-2.95.3/gcc/cp/Make-lang.in	Mon May 27 07:05:27 2002
@@ -87,7 +87,8 @@
 	    $$cp_srcdir/parse.c
 
 # Create the compiler driver for g++.
-GXX_OBJS = gcc.o g++spec.o intl.o prefix.o version.o 
+GXX_OBJS = gcc.o g++spec.o intl.o prefix.o version.o find_cross.o \
+  cross_update_cpu.o
 g++$(exeext): $(GXX_OBJS) $(EXTRA_GCC_OBJS) $(LIBDEPS)
 	$(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ \
 	  $(GXX_OBJS) $(EXTRA_GCC_OBJS) $(LIBS)
@@ -219,6 +220,10 @@
 	    chmod a+x $(bindir)/$(GXX_CROSS_NAME)$(exeext); \
 	    rm -f $(bindir)/$(CXX_CROSS_NAME)$(exeext); \
 	    $(LN) $(bindir)/$(GXX_CROSS_NAME)$(exeext) $(bindir)/$(CXX_CROSS_NAME)$(exeext); \
+	    rm -f $(tooldir)/bin/g++$(exeext); \
+	    ln -s ../../bin/$(GXX_CROSS_NAME)$(exeext) $(tooldir)/bin/g++$(exeext); \
+	    rm -f $(tooldir)/bin/c++$(exeext); \
+            ln -s ../../bin/$(CXX_CROSS_NAME)$(exeext) $(tooldir)/bin/c++$(exeext); \
 	  else \
 	    rm -f $(bindir)/$(GXX_INSTALL_NAME)$(exeext); \
 	    $(INSTALL_PROGRAM) g++$(exeext) $(bindir)/$(GXX_INSTALL_NAME)$(exeext); \
diff -Naur gcc-2.95.3.old/gcc/cppinit.c gcc-2.95.3/gcc/cppinit.c
--- gcc-2.95.3.old/gcc/cppinit.c	Tue Jan 18 21:37:55 2000
+++ gcc-2.95.3/gcc/cppinit.c	Mon May 27 07:05:27 2002
@@ -84,6 +84,12 @@
 #define REGISTER_PREFIX ""
 #endif
 
+extern char *cross_dir;
+extern char *family_cpu;
+
+extern char *replace(char *, char *);
+
+
 /* Suffix for object files, and known input-file extensions. */
 static char *known_suffixes[] =
 {
@@ -121,50 +127,7 @@
 				   be wrapped in extern "C" when compiling
 				   C++.  This is not used anymore.  */
 }
-include_defaults_array[]
-#ifdef INCLUDE_DEFAULTS
-= INCLUDE_DEFAULTS;
-#else
-= {
-    /* Pick up GNU C++ specific include files.  */
-    { GPLUSPLUS_INCLUDE_DIR, "G++", 1, 1 },
-#ifdef CROSS_COMPILE
-    /* This is the dir for fixincludes.  Put it just before
-       the files that we fix.  */
-    { GCC_INCLUDE_DIR, "GCC", 0, 0 },
-    /* For cross-compilation, this dir name is generated
-       automatically in Makefile.in.  */
-    { CROSS_INCLUDE_DIR, "GCC", 0, 0 },
-#ifdef TOOL_INCLUDE_DIR
-    /* This is another place that the target system's headers might be.  */
-    { TOOL_INCLUDE_DIR, "BINUTILS", 0, 1 },
-#endif
-#else /* not CROSS_COMPILE */
-#ifdef LOCAL_INCLUDE_DIR
-    /* This should be /usr/local/include and should come before
-       the fixincludes-fixed header files.  */
-    { LOCAL_INCLUDE_DIR, 0, 0, 1 },
-#endif
-#ifdef TOOL_INCLUDE_DIR
-    /* This is here ahead of GCC_INCLUDE_DIR because assert.h goes here.
-       Likewise, behind LOCAL_INCLUDE_DIR, where glibc puts its assert.h.  */
-    { TOOL_INCLUDE_DIR, "BINUTILS", 0, 1 },
-#endif
-    /* This is the dir for fixincludes.  Put it just before
-       the files that we fix.  */
-    { GCC_INCLUDE_DIR, "GCC", 0, 0 },
-    /* Some systems have an extra dir of include files.  */
-#ifdef SYSTEM_INCLUDE_DIR
-    { SYSTEM_INCLUDE_DIR, 0, 0, 0 },
-#endif
-#ifndef STANDARD_INCLUDE_COMPONENT
-#define STANDARD_INCLUDE_COMPONENT 0
-#endif
-    { STANDARD_INCLUDE_DIR, STANDARD_INCLUDE_COMPONENT, 0, 0 },
-#endif /* not CROSS_COMPILE */
-    { 0, 0, 0, 0 }
-  };
-#endif /* no INCLUDE_DEFAULTS */
+include_defaults_array[10];
 
 /* Internal structures and prototypes. */
 
@@ -775,7 +738,149 @@
   cpp_buffer *fp;
   struct include_hash *ih_fake;
 
-  /* -MG doesn't select the form of output and must be specified with one of
+  /* Generate include_defaults array. The std_prefix was set already by 
+     gcc.c main() function
+   */
+#define add_to_include(_var, _fname, _component, _cplusplus, _cxx_aware, _included) \
+  do { _var.fname     = _fname;      \
+       _var.component = _component;  \
+       _var.cplusplus = _cplusplus;  \
+       _var.cxx_aware = _cxx_aware; } while (0);
+
+
+  int index = 0;
+
+  if (cross_dir) {
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, GPLUSPLUS_INCLUDE_DIR),
+                   "G++", 1, 1);
+    index++;
+#ifdef CROSS_COMPILE
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, GCC_INCLUDE_DIR),
+                   "GCC", 0, 0);
+    index++;
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, CROSS_INCLUDE_DIR),
+                   "GCC", 0, 0);
+    index++;
+  
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, TOOL_INCLUDE_DIR),
+                   "BINUTILS", 0, 1);
+    index++;
+#endif
+    if (family_cpu && *family_cpu)
+    {
+      char * target_include_dir = concat(cross_dir, "/../", 
+                                         family_cpu, "/usr/nclude", NULL_PTR);
+      char * gxx_target_include_dir = concat(cross_dir, "/../",
+					 family_cpu, "/usr/include/g++-3",
+                                         NULL_PTR);
+      if (gxx_target_include_dir) {
+        add_to_include(include_defaults_array[index], gxx_target_include_dir,
+                       0, 1, 1);
+        index++;
+      }
+      if (target_include_dir) {
+        add_to_include(include_defaults_array[index], target_include_dir,
+                       0, 0, 0);
+        index++;
+      }
+    }
+#else /* not CROSS_COMPILE */
+#ifdef LOCAL_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, LOCAL_INCLUDE_DIR), 0, 0, 1);
+    index++;
+#endif
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, TOOL_INCLUDE_DIR),
+                   "BINUTILS", 0, 1);
+    index++;
+#endif
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, GCC_INCLUDE_DIR),
+                   "GCC", 0, 0);
+    index++;
+#ifdef SYSTEM_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], 
+                   replace(cross_dir, SYSTEM_INCLUDE_DIR),
+                   0, 0, 0);
+    index++;
+#endif
+#endif /* not CROSS_COMPILE */
+  }
+  else
+  {
+    add_to_include(include_defaults_array[index], GPLUSPLUS_INCLUDE_DIR,
+                   "G++", 1, 1);
+    index++;
+#ifdef CROSS_COMPILE
+    add_to_include(include_defaults_array[index], GCC_INCLUDE_DIR,
+                   "GCC", 0, 0);
+    index++;
+    add_to_include(include_defaults_array[index], CROSS_INCLUDE_DIR,
+                   "GCC", 0, 0);
+    index++;
+  
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], TOOL_INCLUDE_DIR,
+                   "BINUTILS", 0, 1);
+    index++;
+#endif
+    if (family_cpu && *family_cpu)
+    {
+      char * target_include_dir = concat(get_std_prefix(), "/../",
+                                         family_cpu, "/usr/include", NULL_PTR);
+      char * gxx_target_include_dir = concat(get_std_prefix(), "/../", 
+                                         family_cpu, "/usr/include/g++-3",
+                                         NULL_PTR);
+      if (gxx_target_include_dir) {
+        add_to_include(include_defaults_array[index], gxx_target_include_dir,
+                       0, 1, 1);
+        index++;
+      }
+
+      if (target_include_dir) {
+        add_to_include(include_defaults_array[index], target_include_dir,
+                       0, 0, 0);
+        index++;
+      }
+    }
+#else /* not CROSS_COMPILE */
+#ifdef LOCAL_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], LOCAL_INCLUDE_DIR, 
+                   0, 0, 1);
+    index++;
+#endif
+#ifdef TOOL_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], TOOL_INCLUDE_DIR,
+                   "BINUTILS", 0, 1);
+    index++;
+#endif
+    add_to_include(include_defaults_array[index], GCC_INCLUDE_DIR,
+                   "GCC", 0, 0);
+    index++;
+#ifdef SYSTEM_INCLUDE_DIR
+    add_to_include(include_defaults_array[index], SYSTEM_INCLUDE_DIR,
+                   0, 0, 0);
+    index++;
+#endif
+#endif /* not CROSS_COMPILE */
+  }
+
+#if !defined(CROSS_COMPILE) && !defined(STANDARD_INCLUDE_COMPONENT)
+#define STANDARD_INCLUDE_COMPONENT 0
+#endif
+
+    add_to_include(include_defaults_array[index], 0, 0, 0, 0);
+
+#undef add_to_include
+
+/* -MG doesn't select the form of output and must be specified with one of
      -M or -MM.  -MG doesn't make sense with -MD or -MMD since they don't
      inhibit compilation.  */
   if (opts->print_deps_missing_files
diff -Naur gcc-2.95.3.old/gcc/cross_update_cpu.c gcc-2.95.3/gcc/cross_update_cpu.c
--- gcc-2.95.3.old/gcc/cross_update_cpu.c	Thu Jan  1 03:00:00 1970
+++ gcc-2.95.3/gcc/cross_update_cpu.c	Mon May 27 07:05:27 2002
@@ -0,0 +1,66 @@
+#include <stdio.h>
+#include <string.h>
+
+/* The following structure sets matching between CROSS_COMPILE env. variable
+ * and --mcpu=<cpu> flag values
+ */
+
+static struct target_cpu {
+  char *target_arch;      /* cpu specification in CROSS_COMPILE env. variable */
+  char *cpu_id;           /* cpu specification in the mcpu flag */
+}; 
+
+struct target_cpu ppc_cpu_tbl[] = {
+  {"4xx",  "403" },
+  {"4xxFP","405pm"},
+  {"74xx", "7400"},
+  {"7xx",  "750" },
+  {"82xx", "603" },
+  {"8xx",  "860" }
+};
+
+void cross_update_cpu(argc, argv, family_cpu)
+  int *argc;
+  char ***argv;
+  char *family_cpu;
+{
+  int i;
+  char *cpu;
+
+  if (!strncasecmp(family_cpu, "ppc_", 4))
+  {
+    cpu = family_cpu + 4;
+
+    for (i = 0; i < *argc; i++)
+    {
+      if (!strncmp((*argv)[i], "-mcpu=", 6))
+        break;
+    }
+    if (i == *argc)
+    {
+      /* The user has not specified cpu option - add it */
+      char **newargv = xmalloc((*argc + 1)*sizeof(char *));
+      char *cpu_id = NULL;
+
+      for (i = 0; i < sizeof(ppc_cpu_tbl)/sizeof(ppc_cpu_tbl[0]); i++)
+      {
+        if (! strcmp(ppc_cpu_tbl[i].target_arch, cpu)) {
+          cpu_id = ppc_cpu_tbl[i].cpu_id;
+          break;
+        }
+      }
+      if (cpu_id)
+      {
+        newargv[0] = (*argv)[0];
+        newargv[1] = xmalloc(strlen(cpu_id) + 7);
+        strcpy(newargv[1], "-mcpu=");
+        strcat(newargv[1], cpu_id);
+        for (i = 2; i < *argc + 1; i++)
+          newargv[i] = (*argv)[i-1];
+        *argv = newargv;
+        (*argc)++;
+      }
+    }
+  }
+}
+
diff -Naur gcc-2.95.3.old/gcc/f/Make-lang.in gcc-2.95.3/gcc/f/Make-lang.in
--- gcc-2.95.3.old/gcc/f/Make-lang.in	Mon Jun  7 23:37:23 1999
+++ gcc-2.95.3/gcc/f/Make-lang.in	Mon May 27 07:05:27 2002
@@ -80,10 +80,12 @@
 
 # Create the compiler driver for g77.
 g77$(exeext): gcc.o g77spec.o g77version.o version.o prefix.o intl.o \
+  find_cross.o  cross_update_cpu.o \
   $(LIBDEPS) $(EXTRA_GCC_OBJS)
 	if [ -f lang-f77 ]; then \
 	  $(CC) $(ALL_CFLAGS) $(LDFLAGS) -o $@ gcc.o g77spec.o g77version.o \
-	   version.o prefix.o intl.o $(EXTRA_GCC_OBJS) $(LIBS); \
+	   version.o prefix.o intl.o find_cross.o cross_update_cpu.o \
+	   $(EXTRA_GCC_OBJS) $(LIBS); \
 	else true; fi
 
 # Create a version of the g77 driver which calls the cross-compiler.
diff -Naur gcc-2.95.3.old/gcc/find_cross.c gcc-2.95.3/gcc/find_cross.c
--- gcc-2.95.3.old/gcc/find_cross.c	Thu Jan  1 03:00:00 1970
+++ gcc-2.95.3/gcc/find_cross.c	Mon May 27 07:05:27 2002
@@ -0,0 +1,234 @@
+/* Utility to update paths from internal to external forms.
+   Copyright (C) 1997, 1998, 1999 Free Software Foundation, Inc.
+
+This file is part of GNU CC.
+
+GNU CC is free software; you can redistribute it and/or
+modify it under the terms of the GNU Library General Public
+License as published by the Free Software Foundation; either
+version 2 of the License, or (at your option) any later version.
+
+GCC is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+Library General Public License for more details.
+
+You should have received a copy of the GNU Library General Public
+License along with GCC; see the file COPYING.  If not, write to the Free
+Software Foundation, Inc., 59 Temple Place - Suite 330,
+Boston, MA 02111-1307, USA.  */
+
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+#include <sys/stat.h>
+#include <sys/param.h>
+
+#ifndef PATH_SEPARATOR
+#define PATH_SEPARATOR ':'
+#endif
+
+#ifndef DIR_SEPARATOR
+#define DIR_SEPARATOR '/'
+#endif
+
+static void remove_relative_paths (char * path);
+
+/* Remove relative paths -- .. and . */
+static void
+remove_relative_paths (char * path)
+{
+  char *p, *s;
+
+  p = path;
+  while ((p = strchr (p, DIR_SEPARATOR)))
+  {
+    p++;
+    if (*p == '.')
+    {
+      p++;
+      if (*p == DIR_SEPARATOR)
+      {
+        /*  Translate "/./" ==> "/"  */
+        strcpy (p-2, p);
+      }
+      else if (*p == '.' && *(p+1) == DIR_SEPARATOR)
+      {
+        /*  Translate "/<whatever>/../" ==> "/"  */
+        s = p + 1;
+        p -= 3;
+        while ( p > path && *p != DIR_SEPARATOR)
+          p--;
+        strcpy (p, s);
+      }
+    }
+  }
+}
+
+/* Find cross directory root */
+void find_cross_dir(char *progname, char **ptr, int is_cpp0)
+{
+  char *fullpath = (char *) xmalloc(MAXPATHLEN);
+  char *linkfile = (char *) xmalloc(MAXPATHLEN);
+  char *realpath = (char *) xmalloc(MAXPATHLEN);
+  struct stat file;
+  int ret = 0;
+  char *p;
+  int i;
+
+  *ptr = 0;
+
+  if (strchr (progname, '/'))
+  {
+    if (progname[0] == '/')
+    {
+      /* We have absolute path */
+      strcpy (fullpath, progname);
+    } else {
+      /* We have relative path, prepend $cwd */
+      getcwd (fullpath, MAXPATHLEN);
+      strcat (fullpath, "/");
+      strcat (fullpath, progname);
+    }
+  } else {
+    /* Search pathlist for matching progname  */
+    char *path;
+    char *beg, *end;
+
+    path = getenv("PATH");
+    beg = path;
+    while (1)
+    {
+      for (end = beg; *end && *end != PATH_SEPARATOR; end++) ;
+      strncpy (fullpath, beg, end - beg);
+      fullpath[end - beg] = '\0';
+      if (fullpath[end - beg - 1] == DIR_SEPARATOR)
+        fullpath[end - beg - 1] = '\0';
+      if (strcmp (fullpath, ".") == 0)
+        getcwd (fullpath, MAXPATHLEN);
+      strcat (fullpath, "/");
+      strcat (fullpath, progname);
+      if ((lstat (fullpath, &file) == 0) &&
+        (S_ISREG(file.st_mode) || S_ISLNK(file.st_mode))) break;
+      if (*end == '\0') {
+        free(realpath);
+        goto RET; /* Not found on path */
+      }
+      beg = end + 1;
+    }
+  }
+
+  /* Resolve all symbolic links in the full path */
+  while (fullpath[0])
+  {
+    char *t, *s, *q;
+    int len, off;
+
+    while ((ret = lstat (fullpath, &file)) == 0 && S_ISLNK(file.st_mode))
+    {
+      /* fullpath is a link */
+            linkfile[readlink (fullpath, linkfile, MAXPATHLEN)] = '\0';
+      if (linkfile[0] == DIR_SEPARATOR)
+      {
+        /* Link replaces path */
+        strcpy (fullpath, linkfile);
+      }
+      else
+      {
+        /* Link is relative to current directory */
+        q = strrchr (fullpath, DIR_SEPARATOR);
+        *(q + 1) = '\0';
+        strcat (fullpath, linkfile);
+      }
+      /* We might have added more relative paths -- remove them */
+      remove_relative_paths (fullpath);
+    }
+    if (ret)
+    {
+      free(realpath);
+      goto RET;
+    }
+    /* Strip off the last segment of the path */
+    if ((q = strrchr (fullpath, DIR_SEPARATOR)))
+      *q++ = '\0';
+    else
+      q = fullpath;
+
+    /* Shift realpath right to make room for new segment and slash */
+    off = strlen (q) + 1;
+    len = strlen (realpath);
+    for (i = len; i >= 0; i--)
+      realpath [off + i] = realpath [i];
+
+    /* Copy new segment to realpath */
+    s = q;
+    t = realpath + 1;
+    while (*s)
+      *t++ = *s++;
+
+    /* Stick in separator at beginning of segment. */
+    realpath[0] = DIR_SEPARATOR;
+  }
+
+  /* Split executable name from path */
+  p = strrchr (realpath, DIR_SEPARATOR);
+  *++p = '\0';
+  
+  remove_relative_paths (realpath);
+
+  /* Exclude trailing segments to get to the .../usr directory */
+  /* cpp0 is located in the /usr/lib/gcc-lib/<target>/<version> directory */
+  /* all binaries are located in the /usr/bin */
+  p = realpath;
+  for (i = 0; i< (is_cpp0 ? 5 : 2) ; i++) {
+    if (!(p = strrchr(realpath, '/'))) {
+      free(realpath);
+      goto RET;
+    }
+    *p = '\0';
+  }
+  *ptr = realpath;
+
+RET:
+  free (fullpath);
+  free (linkfile);
+}
+
+/* Replace the initial occurance of PREFIX by the specified prefix */
+
+char *
+replace (char *new_prefix, char *path)
+{
+  int len = strlen(PREFIX);
+
+  if (strcmp(new_prefix, PREFIX) &&
+      ! strncmp (path, PREFIX, len))
+  {
+    char *new = (char *) xmalloc(strlen(new_prefix) +
+                                 strlen(path) - len + 1);
+    strcpy(new, new_prefix);
+    strcat(new, path + len);
+    return new;
+  }
+  return path;
+}
+
+int
+find_family_cpu(char **family_cpu)
+{
+  char *p;
+  int len;
+
+  p = getenv("CROSS_COMPILE");
+  if (p && *p)
+    {
+      p = basename(p);
+      len = strlen(p);
+      *family_cpu = xmalloc(len + 1);
+      strcpy(*family_cpu, p);
+      if ((*family_cpu)[len - 1] == '-')
+        (*family_cpu)[len - 1] = '\0';
+      return 1;
+    }
+  return 0;
+}
